function getOmniItemsOrder() {
  // Get all elements with class 'omni-item'
  const omniItems = document.getElementsByClassName("omni-item");

  // Create an object instead of an array
  const items = Array.from(omniItems).reduce((acc, item, index) => {
    acc[index + 1] = {
      title: item.getAttribute("name"),
      hidden: item.classList.contains("hidden") ? "true" : "false",
    };
    return acc;
  }, {});

  return items;
}

function forwardDataToWordPress(endpoint, data) {
  // Send the data to the specified WordPress REST API endpoint
  $.ajax({
    url: window.homeUrl
      ? window.homeUrl + "/wp-json/proxy/v1/" + endpoint
      : "/wp-json/proxy/v1/" + endpoint,
    method: "POST",
    contentType: "application/json",
    data: JSON.stringify(data),
    success: function (response) {},
    error: function (error) {
      console.error("Error:", error);
    },
  });
}

function attachOutboundLinkHandler() {
  $(document).on("click mousedown contextmenu touchend", "*", function (event) {
    const element = $(this);

    // Only process further if element has href
    var href = element.attr("href");
    if (!href) return;

    var target = element.attr("target");

    if (
      href.indexOf(location.hostname) === -1 &&
      !href.startsWith("#") &&
      !href.startsWith("mailto:") &&
      !href.startsWith("tel:")
    ) {
      if (
        event.type === "click" ||
        event.type === "mousedown" ||
        event.type === "contextmenu" ||
        event.type === "touchend"
      ) {
        if (event.type === "mousedown" && event.which !== 2) {
          return;
        }

        // Always prevent default for click/touchend events on outbound links that aren't opening in new tab
        if (
          (event.type === "click" || event.type === "touchend") &&
          (!target || target !== "_blank")
        ) {
          event.preventDefault();

          // Send data and wait for completion before redirecting
          $.ajax({
            url: window.homeUrl
              ? window.homeUrl + "/wp-json/proxy/v1/handle_outbound_click"
              : "/wp-json/proxy/v1/handle_outbound_click",
            method: "POST",
            contentType: "application/json",
            data: JSON.stringify({
              url: scriptParams.currentUrl,
              ip: scriptParams.ipAddress,
              href: href,
              target: target,
              event: "outbound_click",
              OmniItemsOrder: getOmniItemsOrder(),
              referer: document.referrer || scriptParams.referer || "unknown",
            }),
            complete: function () {
              window.location.href = href;
            },
          });
        } else {
          // For non-click events or new tab opens, just send the data without redirecting
          forwardDataToWordPress("handle_outbound_click", {
            url: scriptParams.currentUrl,
            ip: scriptParams.ipAddress,
            href: href,
            target: target,
            event: "outbound_click",
            OmniItemsOrder: getOmniItemsOrder(),
            referer: document.referrer || scriptParams.referer || "unknown",
          });
        }
      }
    }
  });
}
